CipherSpi (Bouncy Castle Library 1.54 API Specification)
Date: 2015-12-29

org.bouncycastle.jcajce.provider.asymmetric.rsa

## Class CipherSpi

- java.lang.Object
- - javax.crypto.CipherSpi
  - - org.bouncycastle.jcajce.provider.asymmetric.util.BaseCipherSpi
    - - org.bouncycastle.jcajce.provider.asymmetric.rsa.CipherSpi

- Direct Known Subclasses:
    CipherSpi.ISO9796d1Padding, CipherSpi.NoPadding, CipherSpi.OAEPPadding, CipherSpi.PKCS1v1_5Padding, CipherSpi.PKCS1v1_5Padding_PrivateOnly, CipherSpi.PKCS1v1_5Padding_PublicOnly

      public class CipherSpi
      extends BaseCipherSpi

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `CipherSpi.ISO9796d1Padding`
    `static class` | `CipherSpi.NoPadding` classes that inherit from us.
    `static class` | `CipherSpi.OAEPPadding`
    `static class` | `CipherSpi.PKCS1v1_5Padding`
    `static class` | `CipherSpi.PKCS1v1_5Padding_PrivateOnly`
    `static class` | `CipherSpi.PKCS1v1_5Padding_PublicOnly`

  - ### Field Summary

    - ### Fields inherited from class org.bouncycastle.jcajce.provider.asymmetric.util.BaseCipherSpi

      `wrapEngine`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CipherSpi(AsymmetricBlockCipher engine)`
    `CipherSpi(boolean publicKeyOnly, boolean privateKeyOnly, AsymmetricBlockCipher engine)`
    `CipherSpi(javax.crypto.spec.OAEPParameterSpec pSpec)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected byte[]` | `engineDoFinal(byte[] input, int inputOffset, int inputLen)`
    `protected int` | `engineDoFinal(byte[] input, int inputOffset, int inputLen, byte[] output, int outputOffset)`
    `protected int` | `engineGetBlockSize()`
    `protected int` | `engineGetKeySize(java.security.Key key)`
    `protected int` | `engineGetOutputSize(int inputLen)`
    `protected java.security.AlgorithmParameters` | `engineGetParameters()`
    `protected void` | `engineInit(int opmode, java.security.Key key, java.security.spec.AlgorithmParameterSpec params, java.security.SecureRandom random)`
    `protected void` | `engineInit(int opmode, java.security.Key key, java.security.AlgorithmParameters params, java.security.SecureRandom random)`
    `protected void` | `engineInit(int opmode, java.security.Key key, java.security.SecureRandom random)`
    `protected void` | `engineSetMode(java.lang.String mode)`
    `protected void` | `engineSetPadding(java.lang.String padding)`
    `protected byte[]` | `engineUpdate(byte[] input, int inputOffset, int inputLen)`
    `protected int` | `engineUpdate(byte[] input, int inputOffset, int inputLen, byte[] output, int outputOffset)`

    - ### Methods inherited from class org.bouncycastle.jcajce.provider.asymmetric.util.BaseCipherSpi

      `createParametersInstance, engineGetIV, engineUnwrap, engineWrap`

    - ### Methods inherited from class javax.crypto.CipherSpi

      `engineDoFinal, engineUpdate, engineUpdateAAD, engineUpdateAAD`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CipherSpi

          public CipherSpi(AsymmetricBlockCipher engine)

    - #### CipherSpi

          public CipherSpi(javax.crypto.spec.OAEPParameterSpec pSpec)

    - #### CipherSpi

          public CipherSpi(boolean publicKeyOnly,
                   boolean privateKeyOnly,
                   AsymmetricBlockCipher engine)

  - ### Method Detail

    - #### engineGetBlockSize

          protected int engineGetBlockSize()

      Overrides:
        `engineGetBlockSize` in class `BaseCipherSpi`

    - #### engineGetKeySize

          protected int engineGetKeySize(java.security.Key key)

      Overrides:
        `engineGetKeySize` in class `BaseCipherSpi`

    - #### engineGetOutputSize

          protected int engineGetOutputSize(int inputLen)

      Overrides:
        `engineGetOutputSize` in class `BaseCipherSpi`

    - #### engineGetParameters

          protected java.security.AlgorithmParameters engineGetParameters()

      Overrides:
        `engineGetParameters` in class `BaseCipherSpi`

    - #### engineSetMode

          protected void engineSetMode(java.lang.String mode)
                                throws java.security.NoSuchAlgorithmException

      Overrides:
        `engineSetMode` in class `BaseCipherSpi`
      Throws:
        `java.security.NoSuchAlgorithmException`

    - #### engineSetPadding

          protected void engineSetPadding(java.lang.String padding)
                                   throws javax.crypto.NoSuchPaddingException

      Overrides:
        `engineSetPadding` in class `BaseCipherSpi`
      Throws:
        `javax.crypto.NoSuchPaddingException`

    - #### engineInit

          protected void engineInit(int opmode,
                        java.security.Key key,
                        java.security.spec.AlgorithmParameterSpec params,
                        java.security.SecureRandom random)
                             throws java.security.InvalidKeyException,
                                    java.security.InvalidAlgorithmParameterException

      Specified by:
        `engineInit` in class `javax.crypto.CipherSpi`
      Throws:
        `java.security.InvalidKeyException`
        `java.security.InvalidAlgorithmParameterException`

    - #### engineInit

          protected void engineInit(int opmode,
                        java.security.Key key,
                        java.security.AlgorithmParameters params,
                        java.security.SecureRandom random)
                             throws java.security.InvalidKeyException,
                                    java.security.InvalidAlgorithmParameterException

      Specified by:
        `engineInit` in class `javax.crypto.CipherSpi`
      Throws:
        `java.security.InvalidKeyException`
        `java.security.InvalidAlgorithmParameterException`

    - #### engineInit

          protected void engineInit(int opmode,
                        java.security.Key key,
                        java.security.SecureRandom random)
                             throws java.security.InvalidKeyException

      Specified by:
        `engineInit` in class `javax.crypto.CipherSpi`
      Throws:
        `java.security.InvalidKeyException`

    - #### engineUpdate

          protected byte[] engineUpdate(byte[] input,
                            int inputOffset,
                            int inputLen)

      Specified by:
        `engineUpdate` in class `javax.crypto.CipherSpi`

    - #### engineUpdate

          protected int engineUpdate(byte[] input,
                         int inputOffset,
                         int inputLen,
                         byte[] output,
                         int outputOffset)

      Specified by:
        `engineUpdate` in class `javax.crypto.CipherSpi`

    - #### engineDoFinal

          protected byte[] engineDoFinal(byte[] input,
                             int inputOffset,
                             int inputLen)
                                  throws javax.crypto.IllegalBlockSizeException,
                                         javax.crypto.BadPaddingException

      Specified by:
        `engineDoFinal` in class `javax.crypto.CipherSpi`
      Throws:
        `javax.crypto.IllegalBlockSizeException`
        `javax.crypto.BadPaddingException`

    - #### engineDoFinal

          protected int engineDoFinal(byte[] input,
                          int inputOffset,
                          int inputLen,
                          byte[] output,
                          int outputOffset)
                               throws javax.crypto.IllegalBlockSizeException,
                                      javax.crypto.BadPaddingException

      Specified by:
        `engineDoFinal` in class `javax.crypto.CipherSpi`
      Throws:
        `javax.crypto.IllegalBlockSizeException`
        `javax.crypto.BadPaddingException`